﻿//  ------Copyright header----------------------------------------------------------
//  <copyright file=Program.cs company="GB Software Development">
//         2019.12.17 Copyright © Goos van Beek - All rights reserved.
//  </copyright>
//  -----------------------------------------------------------------------------------
namespace ConsoleApp1{
    #region usings
    using System;
    using OpcLabs.BaseLib.ComInterop;
    using OpcLabs.EasyOpc.DataAccess;
    #endregion
    class Program{
        private static readonly EasyDAClient Client = new EasyDAClient();
        static void Main(){
            Client.SubscribeItem(
                "http://opcxml.demo-this.com/XmlDaSampleServer/Service.asmx", 
                "Dynamic/Analog Types/Int", 
                1000, 
                (_, args)=>Console.WriteLine(args.Vtq?.Value), 
                null);

            // System.Runtime.InteropServices.COMException (0x800401F3): Invalid class string
            Client.SubscribeItem(
                string.Empty, 
                "http://opcxml.demo-this.com/XmlDaSampleServer/Service.asmx", 
                "Dynamic/Analog Types/Double", 
                VarTypes.Empty, 
                1000, 
                0.01F, 
                (_, args)=>Console.WriteLine(args.Exception ?? args.Vtq?.Value),
                null);

            Console.ReadKey();
        }
    }
}